"""
Type annotations for elbv2 service type definitions.

[Open documentation](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_elbv2/type_defs/)

Usage::

    ```python
    from mypy_boto3_elbv2.type_defs import AuthenticateCognitoActionConfigPaginatorTypeDef

    data: AuthenticateCognitoActionConfigPaginatorTypeDef = ...
    ```
"""
import sys
from datetime import datetime
from typing import Dict, List, Mapping, Sequence

from .literals import (
    ActionTypeEnumType,
    AuthenticateCognitoActionConditionalBehaviorEnumType,
    AuthenticateOidcActionConditionalBehaviorEnumType,
    EnforceSecurityGroupInboundRulesOnPrivateLinkTrafficEnumType,
    IpAddressTypeType,
    LoadBalancerSchemeEnumType,
    LoadBalancerStateEnumType,
    LoadBalancerTypeEnumType,
    ProtocolEnumType,
    RedirectActionStatusCodeEnumType,
    TargetGroupIpAddressTypeEnumType,
    TargetHealthReasonEnumType,
    TargetHealthStateEnumType,
    TargetTypeEnumType,
)

if sys.version_info >= (3, 12):
    from typing import NotRequired
else:
    from typing_extensions import NotRequired
if sys.version_info >= (3, 12):
    from typing import TypedDict
else:
    from typing_extensions import TypedDict


__all__ = (
    "AuthenticateCognitoActionConfigPaginatorTypeDef",
    "AuthenticateOidcActionConfigPaginatorTypeDef",
    "FixedResponseActionConfigTypeDef",
    "RedirectActionConfigTypeDef",
    "AuthenticateCognitoActionConfigTypeDef",
    "AuthenticateOidcActionConfigTypeDef",
    "CertificateTypeDef",
    "ResponseMetadataTypeDef",
    "TagTypeDef",
    "LoadBalancerAddressTypeDef",
    "CipherTypeDef",
    "SubnetMappingTypeDef",
    "MatcherTypeDef",
    "DeleteListenerInputRequestTypeDef",
    "DeleteLoadBalancerInputRequestTypeDef",
    "DeleteRuleInputRequestTypeDef",
    "DeleteTargetGroupInputRequestTypeDef",
    "TargetDescriptionTypeDef",
    "PaginatorConfigTypeDef",
    "DescribeAccountLimitsInputRequestTypeDef",
    "LimitTypeDef",
    "DescribeListenerCertificatesInputRequestTypeDef",
    "DescribeListenersInputRequestTypeDef",
    "DescribeLoadBalancerAttributesInputRequestTypeDef",
    "LoadBalancerAttributeTypeDef",
    "WaiterConfigTypeDef",
    "DescribeLoadBalancersInputRequestTypeDef",
    "DescribeRulesInputRequestTypeDef",
    "DescribeSSLPoliciesInputRequestTypeDef",
    "DescribeTagsInputRequestTypeDef",
    "DescribeTargetGroupAttributesInputRequestTypeDef",
    "TargetGroupAttributeTypeDef",
    "DescribeTargetGroupsInputRequestTypeDef",
    "TargetGroupStickinessConfigTypeDef",
    "TargetGroupTupleTypeDef",
    "HostHeaderConditionConfigPaginatorTypeDef",
    "HostHeaderConditionConfigTypeDef",
    "HttpHeaderConditionConfigPaginatorTypeDef",
    "HttpHeaderConditionConfigTypeDef",
    "HttpRequestMethodConditionConfigPaginatorTypeDef",
    "HttpRequestMethodConditionConfigTypeDef",
    "LoadBalancerStateTypeDef",
    "PathPatternConditionConfigPaginatorTypeDef",
    "PathPatternConditionConfigTypeDef",
    "QueryStringKeyValuePairTypeDef",
    "RemoveTagsInputRequestTypeDef",
    "SourceIpConditionConfigPaginatorTypeDef",
    "SourceIpConditionConfigTypeDef",
    "RulePriorityPairTypeDef",
    "SetIpAddressTypeInputRequestTypeDef",
    "SetSecurityGroupsInputRequestTypeDef",
    "TargetHealthTypeDef",
    "AddListenerCertificatesInputRequestTypeDef",
    "RemoveListenerCertificatesInputRequestTypeDef",
    "AddListenerCertificatesOutputTypeDef",
    "DescribeListenerCertificatesOutputTypeDef",
    "SetIpAddressTypeOutputTypeDef",
    "SetSecurityGroupsOutputTypeDef",
    "AddTagsInputRequestTypeDef",
    "TagDescriptionTypeDef",
    "AvailabilityZoneTypeDef",
    "SslPolicyTypeDef",
    "CreateLoadBalancerInputRequestTypeDef",
    "SetSubnetsInputRequestTypeDef",
    "CreateTargetGroupInputRequestTypeDef",
    "ModifyTargetGroupInputRequestTypeDef",
    "TargetGroupTypeDef",
    "DeregisterTargetsInputRequestTypeDef",
    "DescribeTargetHealthInputRequestTypeDef",
    "RegisterTargetsInputRequestTypeDef",
    "DescribeAccountLimitsInputDescribeAccountLimitsPaginateTypeDef",
    "DescribeListenerCertificatesInputDescribeListenerCertificatesPaginateTypeDef",
    "DescribeListenersInputDescribeListenersPaginateTypeDef",
    "DescribeLoadBalancersInputDescribeLoadBalancersPaginateTypeDef",
    "DescribeRulesInputDescribeRulesPaginateTypeDef",
    "DescribeSSLPoliciesInputDescribeSSLPoliciesPaginateTypeDef",
    "DescribeTargetGroupsInputDescribeTargetGroupsPaginateTypeDef",
    "DescribeAccountLimitsOutputTypeDef",
    "DescribeLoadBalancerAttributesOutputTypeDef",
    "ModifyLoadBalancerAttributesInputRequestTypeDef",
    "ModifyLoadBalancerAttributesOutputTypeDef",
    "DescribeLoadBalancersInputLoadBalancerAvailableWaitTypeDef",
    "DescribeLoadBalancersInputLoadBalancerExistsWaitTypeDef",
    "DescribeLoadBalancersInputLoadBalancersDeletedWaitTypeDef",
    "DescribeTargetHealthInputTargetDeregisteredWaitTypeDef",
    "DescribeTargetHealthInputTargetInServiceWaitTypeDef",
    "DescribeTargetGroupAttributesOutputTypeDef",
    "ModifyTargetGroupAttributesInputRequestTypeDef",
    "ModifyTargetGroupAttributesOutputTypeDef",
    "ForwardActionConfigPaginatorTypeDef",
    "ForwardActionConfigTypeDef",
    "QueryStringConditionConfigPaginatorTypeDef",
    "QueryStringConditionConfigTypeDef",
    "SetRulePrioritiesInputRequestTypeDef",
    "TargetHealthDescriptionTypeDef",
    "DescribeTagsOutputTypeDef",
    "LoadBalancerTypeDef",
    "SetSubnetsOutputTypeDef",
    "DescribeSSLPoliciesOutputTypeDef",
    "CreateTargetGroupOutputTypeDef",
    "DescribeTargetGroupsOutputTypeDef",
    "ModifyTargetGroupOutputTypeDef",
    "ActionPaginatorTypeDef",
    "ActionTypeDef",
    "RuleConditionPaginatorTypeDef",
    "RuleConditionTypeDef",
    "DescribeTargetHealthOutputTypeDef",
    "CreateLoadBalancerOutputTypeDef",
    "DescribeLoadBalancersOutputTypeDef",
    "ListenerPaginatorTypeDef",
    "CreateListenerInputRequestTypeDef",
    "ListenerTypeDef",
    "ModifyListenerInputRequestTypeDef",
    "RulePaginatorTypeDef",
    "CreateRuleInputRequestTypeDef",
    "ModifyRuleInputRequestTypeDef",
    "RuleTypeDef",
    "DescribeListenersOutputPaginatorTypeDef",
    "CreateListenerOutputTypeDef",
    "DescribeListenersOutputTypeDef",
    "ModifyListenerOutputTypeDef",
    "DescribeRulesOutputPaginatorTypeDef",
    "CreateRuleOutputTypeDef",
    "DescribeRulesOutputTypeDef",
    "ModifyRuleOutputTypeDef",
    "SetRulePrioritiesOutputTypeDef",
)

AuthenticateCognitoActionConfigPaginatorTypeDef = TypedDict(
    "AuthenticateCognitoActionConfigPaginatorTypeDef",
    {
        "UserPoolArn": str,
        "UserPoolClientId": str,
        "UserPoolDomain": str,
        "SessionCookieName": NotRequired[str],
        "Scope": NotRequired[str],
        "SessionTimeout": NotRequired[int],
        "AuthenticationRequestExtraParams": NotRequired[Dict[str, str]],
        "OnUnauthenticatedRequest": NotRequired[
            AuthenticateCognitoActionConditionalBehaviorEnumType
        ],
    },
)

AuthenticateOidcActionConfigPaginatorTypeDef = TypedDict(
    "AuthenticateOidcActionConfigPaginatorTypeDef",
    {
        "Issuer": str,
        "AuthorizationEndpoint": str,
        "TokenEndpoint": str,
        "UserInfoEndpoint": str,
        "ClientId": str,
        "ClientSecret": NotRequired[str],
        "SessionCookieName": NotRequired[str],
        "Scope": NotRequired[str],
        "SessionTimeout": NotRequired[int],
        "AuthenticationRequestExtraParams": NotRequired[Dict[str, str]],
        "OnUnauthenticatedRequest": NotRequired[AuthenticateOidcActionConditionalBehaviorEnumType],
        "UseExistingClientSecret": NotRequired[bool],
    },
)

FixedResponseActionConfigTypeDef = TypedDict(
    "FixedResponseActionConfigTypeDef",
    {
        "StatusCode": str,
        "MessageBody": NotRequired[str],
        "ContentType": NotRequired[str],
    },
)

RedirectActionConfigTypeDef = TypedDict(
    "RedirectActionConfigTypeDef",
    {
        "StatusCode": RedirectActionStatusCodeEnumType,
        "Protocol": NotRequired[str],
        "Port": NotRequired[str],
        "Host": NotRequired[str],
        "Path": NotRequired[str],
        "Query": NotRequired[str],
    },
)

AuthenticateCognitoActionConfigTypeDef = TypedDict(
    "AuthenticateCognitoActionConfigTypeDef",
    {
        "UserPoolArn": str,
        "UserPoolClientId": str,
        "UserPoolDomain": str,
        "SessionCookieName": NotRequired[str],
        "Scope": NotRequired[str],
        "SessionTimeout": NotRequired[int],
        "AuthenticationRequestExtraParams": NotRequired[Mapping[str, str]],
        "OnUnauthenticatedRequest": NotRequired[
            AuthenticateCognitoActionConditionalBehaviorEnumType
        ],
    },
)

AuthenticateOidcActionConfigTypeDef = TypedDict(
    "AuthenticateOidcActionConfigTypeDef",
    {
        "Issuer": str,
        "AuthorizationEndpoint": str,
        "TokenEndpoint": str,
        "UserInfoEndpoint": str,
        "ClientId": str,
        "ClientSecret": NotRequired[str],
        "SessionCookieName": NotRequired[str],
        "Scope": NotRequired[str],
        "SessionTimeout": NotRequired[int],
        "AuthenticationRequestExtraParams": NotRequired[Mapping[str, str]],
        "OnUnauthenticatedRequest": NotRequired[AuthenticateOidcActionConditionalBehaviorEnumType],
        "UseExistingClientSecret": NotRequired[bool],
    },
)

CertificateTypeDef = TypedDict(
    "CertificateTypeDef",
    {
        "CertificateArn": NotRequired[str],
        "IsDefault": NotRequired[bool],
    },
)

ResponseMetadataTypeDef = TypedDict(
    "ResponseMetadataTypeDef",
    {
        "RequestId": str,
        "HostId": str,
        "HTTPStatusCode": int,
        "HTTPHeaders": Dict[str, str],
        "RetryAttempts": int,
    },
)

TagTypeDef = TypedDict(
    "TagTypeDef",
    {
        "Key": str,
        "Value": NotRequired[str],
    },
)

LoadBalancerAddressTypeDef = TypedDict(
    "LoadBalancerAddressTypeDef",
    {
        "IpAddress": NotRequired[str],
        "AllocationId": NotRequired[str],
        "PrivateIPv4Address": NotRequired[str],
        "IPv6Address": NotRequired[str],
    },
)

CipherTypeDef = TypedDict(
    "CipherTypeDef",
    {
        "Name": NotRequired[str],
        "Priority": NotRequired[int],
    },
)

SubnetMappingTypeDef = TypedDict(
    "SubnetMappingTypeDef",
    {
        "SubnetId": NotRequired[str],
        "AllocationId": NotRequired[str],
        "PrivateIPv4Address": NotRequired[str],
        "IPv6Address": NotRequired[str],
    },
)

MatcherTypeDef = TypedDict(
    "MatcherTypeDef",
    {
        "HttpCode": NotRequired[str],
        "GrpcCode": NotRequired[str],
    },
)

DeleteListenerInputRequestTypeDef = TypedDict(
    "DeleteListenerInputRequestTypeDef",
    {
        "ListenerArn": str,
    },
)

DeleteLoadBalancerInputRequestTypeDef = TypedDict(
    "DeleteLoadBalancerInputRequestTypeDef",
    {
        "LoadBalancerArn": str,
    },
)

DeleteRuleInputRequestTypeDef = TypedDict(
    "DeleteRuleInputRequestTypeDef",
    {
        "RuleArn": str,
    },
)

DeleteTargetGroupInputRequestTypeDef = TypedDict(
    "DeleteTargetGroupInputRequestTypeDef",
    {
        "TargetGroupArn": str,
    },
)

TargetDescriptionTypeDef = TypedDict(
    "TargetDescriptionTypeDef",
    {
        "Id": str,
        "Port": NotRequired[int],
        "AvailabilityZone": NotRequired[str],
    },
)

PaginatorConfigTypeDef = TypedDict(
    "PaginatorConfigTypeDef",
    {
        "MaxItems": NotRequired[int],
        "PageSize": NotRequired[int],
        "StartingToken": NotRequired[str],
    },
)

DescribeAccountLimitsInputRequestTypeDef = TypedDict(
    "DescribeAccountLimitsInputRequestTypeDef",
    {
        "Marker": NotRequired[str],
        "PageSize": NotRequired[int],
    },
)

LimitTypeDef = TypedDict(
    "LimitTypeDef",
    {
        "Name": NotRequired[str],
        "Max": NotRequired[str],
    },
)

DescribeListenerCertificatesInputRequestTypeDef = TypedDict(
    "DescribeListenerCertificatesInputRequestTypeDef",
    {
        "ListenerArn": str,
        "Marker": NotRequired[str],
        "PageSize": NotRequired[int],
    },
)

DescribeListenersInputRequestTypeDef = TypedDict(
    "DescribeListenersInputRequestTypeDef",
    {
        "LoadBalancerArn": NotRequired[str],
        "ListenerArns": NotRequired[Sequence[str]],
        "Marker": NotRequired[str],
        "PageSize": NotRequired[int],
    },
)

DescribeLoadBalancerAttributesInputRequestTypeDef = TypedDict(
    "DescribeLoadBalancerAttributesInputRequestTypeDef",
    {
        "LoadBalancerArn": str,
    },
)

LoadBalancerAttributeTypeDef = TypedDict(
    "LoadBalancerAttributeTypeDef",
    {
        "Key": NotRequired[str],
        "Value": NotRequired[str],
    },
)

WaiterConfigTypeDef = TypedDict(
    "WaiterConfigTypeDef",
    {
        "Delay": NotRequired[int],
        "MaxAttempts": NotRequired[int],
    },
)

DescribeLoadBalancersInputRequestTypeDef = TypedDict(
    "DescribeLoadBalancersInputRequestTypeDef",
    {
        "LoadBalancerArns": NotRequired[Sequence[str]],
        "Names": NotRequired[Sequence[str]],
        "Marker": NotRequired[str],
        "PageSize": NotRequired[int],
    },
)

DescribeRulesInputRequestTypeDef = TypedDict(
    "DescribeRulesInputRequestTypeDef",
    {
        "ListenerArn": NotRequired[str],
        "RuleArns": NotRequired[Sequence[str]],
        "Marker": NotRequired[str],
        "PageSize": NotRequired[int],
    },
)

DescribeSSLPoliciesInputRequestTypeDef = TypedDict(
    "DescribeSSLPoliciesInputRequestTypeDef",
    {
        "Names": NotRequired[Sequence[str]],
        "Marker": NotRequired[str],
        "PageSize": NotRequired[int],
        "LoadBalancerType": NotRequired[LoadBalancerTypeEnumType],
    },
)

DescribeTagsInputRequestTypeDef = TypedDict(
    "DescribeTagsInputRequestTypeDef",
    {
        "ResourceArns": Sequence[str],
    },
)

DescribeTargetGroupAttributesInputRequestTypeDef = TypedDict(
    "DescribeTargetGroupAttributesInputRequestTypeDef",
    {
        "TargetGroupArn": str,
    },
)

TargetGroupAttributeTypeDef = TypedDict(
    "TargetGroupAttributeTypeDef",
    {
        "Key": NotRequired[str],
        "Value": NotRequired[str],
    },
)

DescribeTargetGroupsInputRequestTypeDef = TypedDict(
    "DescribeTargetGroupsInputRequestTypeDef",
    {
        "LoadBalancerArn": NotRequired[str],
        "TargetGroupArns": NotRequired[Sequence[str]],
        "Names": NotRequired[Sequence[str]],
        "Marker": NotRequired[str],
        "PageSize": NotRequired[int],
    },
)

TargetGroupStickinessConfigTypeDef = TypedDict(
    "TargetGroupStickinessConfigTypeDef",
    {
        "Enabled": NotRequired[bool],
        "DurationSeconds": NotRequired[int],
    },
)

TargetGroupTupleTypeDef = TypedDict(
    "TargetGroupTupleTypeDef",
    {
        "TargetGroupArn": NotRequired[str],
        "Weight": NotRequired[int],
    },
)

HostHeaderConditionConfigPaginatorTypeDef = TypedDict(
    "HostHeaderConditionConfigPaginatorTypeDef",
    {
        "Values": NotRequired[List[str]],
    },
)

HostHeaderConditionConfigTypeDef = TypedDict(
    "HostHeaderConditionConfigTypeDef",
    {
        "Values": NotRequired[Sequence[str]],
    },
)

HttpHeaderConditionConfigPaginatorTypeDef = TypedDict(
    "HttpHeaderConditionConfigPaginatorTypeDef",
    {
        "HttpHeaderName": NotRequired[str],
        "Values": NotRequired[List[str]],
    },
)

HttpHeaderConditionConfigTypeDef = TypedDict(
    "HttpHeaderConditionConfigTypeDef",
    {
        "HttpHeaderName": NotRequired[str],
        "Values": NotRequired[Sequence[str]],
    },
)

HttpRequestMethodConditionConfigPaginatorTypeDef = TypedDict(
    "HttpRequestMethodConditionConfigPaginatorTypeDef",
    {
        "Values": NotRequired[List[str]],
    },
)

HttpRequestMethodConditionConfigTypeDef = TypedDict(
    "HttpRequestMethodConditionConfigTypeDef",
    {
        "Values": NotRequired[Sequence[str]],
    },
)

LoadBalancerStateTypeDef = TypedDict(
    "LoadBalancerStateTypeDef",
    {
        "Code": NotRequired[LoadBalancerStateEnumType],
        "Reason": NotRequired[str],
    },
)

PathPatternConditionConfigPaginatorTypeDef = TypedDict(
    "PathPatternConditionConfigPaginatorTypeDef",
    {
        "Values": NotRequired[List[str]],
    },
)

PathPatternConditionConfigTypeDef = TypedDict(
    "PathPatternConditionConfigTypeDef",
    {
        "Values": NotRequired[Sequence[str]],
    },
)

QueryStringKeyValuePairTypeDef = TypedDict(
    "QueryStringKeyValuePairTypeDef",
    {
        "Key": NotRequired[str],
        "Value": NotRequired[str],
    },
)

RemoveTagsInputRequestTypeDef = TypedDict(
    "RemoveTagsInputRequestTypeDef",
    {
        "ResourceArns": Sequence[str],
        "TagKeys": Sequence[str],
    },
)

SourceIpConditionConfigPaginatorTypeDef = TypedDict(
    "SourceIpConditionConfigPaginatorTypeDef",
    {
        "Values": NotRequired[List[str]],
    },
)

SourceIpConditionConfigTypeDef = TypedDict(
    "SourceIpConditionConfigTypeDef",
    {
        "Values": NotRequired[Sequence[str]],
    },
)

RulePriorityPairTypeDef = TypedDict(
    "RulePriorityPairTypeDef",
    {
        "RuleArn": NotRequired[str],
        "Priority": NotRequired[int],
    },
)

SetIpAddressTypeInputRequestTypeDef = TypedDict(
    "SetIpAddressTypeInputRequestTypeDef",
    {
        "LoadBalancerArn": str,
        "IpAddressType": IpAddressTypeType,
    },
)

SetSecurityGroupsInputRequestTypeDef = TypedDict(
    "SetSecurityGroupsInputRequestTypeDef",
    {
        "LoadBalancerArn": str,
        "SecurityGroups": Sequence[str],
        "EnforceSecurityGroupInboundRulesOnPrivateLinkTraffic": NotRequired[
            EnforceSecurityGroupInboundRulesOnPrivateLinkTrafficEnumType
        ],
    },
)

TargetHealthTypeDef = TypedDict(
    "TargetHealthTypeDef",
    {
        "State": NotRequired[TargetHealthStateEnumType],
        "Reason": NotRequired[TargetHealthReasonEnumType],
        "Description": NotRequired[str],
    },
)

AddListenerCertificatesInputRequestTypeDef = TypedDict(
    "AddListenerCertificatesInputRequestTypeDef",
    {
        "ListenerArn": str,
        "Certificates": Sequence[CertificateTypeDef],
    },
)

RemoveListenerCertificatesInputRequestTypeDef = TypedDict(
    "RemoveListenerCertificatesInputRequestTypeDef",
    {
        "ListenerArn": str,
        "Certificates": Sequence[CertificateTypeDef],
    },
)

AddListenerCertificatesOutputTypeDef = TypedDict(
    "AddListenerCertificatesOutputTypeDef",
    {
        "Certificates": List[CertificateTypeDef],
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

DescribeListenerCertificatesOutputTypeDef = TypedDict(
    "DescribeListenerCertificatesOutputTypeDef",
    {
        "Certificates": List[CertificateTypeDef],
        "NextMarker": str,
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

SetIpAddressTypeOutputTypeDef = TypedDict(
    "SetIpAddressTypeOutputTypeDef",
    {
        "IpAddressType": IpAddressTypeType,
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

SetSecurityGroupsOutputTypeDef = TypedDict(
    "SetSecurityGroupsOutputTypeDef",
    {
        "SecurityGroupIds": List[str],
        "EnforceSecurityGroupInboundRulesOnPrivateLinkTraffic": (
            EnforceSecurityGroupInboundRulesOnPrivateLinkTrafficEnumType
        ),
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

AddTagsInputRequestTypeDef = TypedDict(
    "AddTagsInputRequestTypeDef",
    {
        "ResourceArns": Sequence[str],
        "Tags": Sequence[TagTypeDef],
    },
)

TagDescriptionTypeDef = TypedDict(
    "TagDescriptionTypeDef",
    {
        "ResourceArn": NotRequired[str],
        "Tags": NotRequired[List[TagTypeDef]],
    },
)

AvailabilityZoneTypeDef = TypedDict(
    "AvailabilityZoneTypeDef",
    {
        "ZoneName": NotRequired[str],
        "SubnetId": NotRequired[str],
        "OutpostId": NotRequired[str],
        "LoadBalancerAddresses": NotRequired[List[LoadBalancerAddressTypeDef]],
    },
)

SslPolicyTypeDef = TypedDict(
    "SslPolicyTypeDef",
    {
        "SslProtocols": NotRequired[List[str]],
        "Ciphers": NotRequired[List[CipherTypeDef]],
        "Name": NotRequired[str],
        "SupportedLoadBalancerTypes": NotRequired[List[str]],
    },
)

CreateLoadBalancerInputRequestTypeDef = TypedDict(
    "CreateLoadBalancerInputRequestTypeDef",
    {
        "Name": str,
        "Subnets": NotRequired[Sequence[str]],
        "SubnetMappings": NotRequired[Sequence[SubnetMappingTypeDef]],
        "SecurityGroups": NotRequired[Sequence[str]],
        "Scheme": NotRequired[LoadBalancerSchemeEnumType],
        "Tags": NotRequired[Sequence[TagTypeDef]],
        "Type": NotRequired[LoadBalancerTypeEnumType],
        "IpAddressType": NotRequired[IpAddressTypeType],
        "CustomerOwnedIpv4Pool": NotRequired[str],
    },
)

SetSubnetsInputRequestTypeDef = TypedDict(
    "SetSubnetsInputRequestTypeDef",
    {
        "LoadBalancerArn": str,
        "Subnets": NotRequired[Sequence[str]],
        "SubnetMappings": NotRequired[Sequence[SubnetMappingTypeDef]],
        "IpAddressType": NotRequired[IpAddressTypeType],
    },
)

CreateTargetGroupInputRequestTypeDef = TypedDict(
    "CreateTargetGroupInputRequestTypeDef",
    {
        "Name": str,
        "Protocol": NotRequired[ProtocolEnumType],
        "ProtocolVersion": NotRequired[str],
        "Port": NotRequired[int],
        "VpcId": NotRequired[str],
        "HealthCheckProtocol": NotRequired[ProtocolEnumType],
        "HealthCheckPort": NotRequired[str],
        "HealthCheckEnabled": NotRequired[bool],
        "HealthCheckPath": NotRequired[str],
        "HealthCheckIntervalSeconds": NotRequired[int],
        "HealthCheckTimeoutSeconds": NotRequired[int],
        "HealthyThresholdCount": NotRequired[int],
        "UnhealthyThresholdCount": NotRequired[int],
        "Matcher": NotRequired[MatcherTypeDef],
        "TargetType": NotRequired[TargetTypeEnumType],
        "Tags": NotRequired[Sequence[TagTypeDef]],
        "IpAddressType": NotRequired[TargetGroupIpAddressTypeEnumType],
    },
)

ModifyTargetGroupInputRequestTypeDef = TypedDict(
    "ModifyTargetGroupInputRequestTypeDef",
    {
        "TargetGroupArn": str,
        "HealthCheckProtocol": NotRequired[ProtocolEnumType],
        "HealthCheckPort": NotRequired[str],
        "HealthCheckPath": NotRequired[str],
        "HealthCheckEnabled": NotRequired[bool],
        "HealthCheckIntervalSeconds": NotRequired[int],
        "HealthCheckTimeoutSeconds": NotRequired[int],
        "HealthyThresholdCount": NotRequired[int],
        "UnhealthyThresholdCount": NotRequired[int],
        "Matcher": NotRequired[MatcherTypeDef],
    },
)

TargetGroupTypeDef = TypedDict(
    "TargetGroupTypeDef",
    {
        "TargetGroupArn": NotRequired[str],
        "TargetGroupName": NotRequired[str],
        "Protocol": NotRequired[ProtocolEnumType],
        "Port": NotRequired[int],
        "VpcId": NotRequired[str],
        "HealthCheckProtocol": NotRequired[ProtocolEnumType],
        "HealthCheckPort": NotRequired[str],
        "HealthCheckEnabled": NotRequired[bool],
        "HealthCheckIntervalSeconds": NotRequired[int],
        "HealthCheckTimeoutSeconds": NotRequired[int],
        "HealthyThresholdCount": NotRequired[int],
        "UnhealthyThresholdCount": NotRequired[int],
        "HealthCheckPath": NotRequired[str],
        "Matcher": NotRequired[MatcherTypeDef],
        "LoadBalancerArns": NotRequired[List[str]],
        "TargetType": NotRequired[TargetTypeEnumType],
        "ProtocolVersion": NotRequired[str],
        "IpAddressType": NotRequired[TargetGroupIpAddressTypeEnumType],
    },
)

DeregisterTargetsInputRequestTypeDef = TypedDict(
    "DeregisterTargetsInputRequestTypeDef",
    {
        "TargetGroupArn": str,
        "Targets": Sequence[TargetDescriptionTypeDef],
    },
)

DescribeTargetHealthInputRequestTypeDef = TypedDict(
    "DescribeTargetHealthInputRequestTypeDef",
    {
        "TargetGroupArn": str,
        "Targets": NotRequired[Sequence[TargetDescriptionTypeDef]],
    },
)

RegisterTargetsInputRequestTypeDef = TypedDict(
    "RegisterTargetsInputRequestTypeDef",
    {
        "TargetGroupArn": str,
        "Targets": Sequence[TargetDescriptionTypeDef],
    },
)

DescribeAccountLimitsInputDescribeAccountLimitsPaginateTypeDef = TypedDict(
    "DescribeAccountLimitsInputDescribeAccountLimitsPaginateTypeDef",
    {
        "PaginationConfig": NotRequired[PaginatorConfigTypeDef],
    },
)

DescribeListenerCertificatesInputDescribeListenerCertificatesPaginateTypeDef = TypedDict(
    "DescribeListenerCertificatesInputDescribeListenerCertificatesPaginateTypeDef",
    {
        "ListenerArn": str,
        "PaginationConfig": NotRequired[PaginatorConfigTypeDef],
    },
)

DescribeListenersInputDescribeListenersPaginateTypeDef = TypedDict(
    "DescribeListenersInputDescribeListenersPaginateTypeDef",
    {
        "LoadBalancerArn": NotRequired[str],
        "ListenerArns": NotRequired[Sequence[str]],
        "PaginationConfig": NotRequired[PaginatorConfigTypeDef],
    },
)

DescribeLoadBalancersInputDescribeLoadBalancersPaginateTypeDef = TypedDict(
    "DescribeLoadBalancersInputDescribeLoadBalancersPaginateTypeDef",
    {
        "LoadBalancerArns": NotRequired[Sequence[str]],
        "Names": NotRequired[Sequence[str]],
        "PaginationConfig": NotRequired[PaginatorConfigTypeDef],
    },
)

DescribeRulesInputDescribeRulesPaginateTypeDef = TypedDict(
    "DescribeRulesInputDescribeRulesPaginateTypeDef",
    {
        "ListenerArn": NotRequired[str],
        "RuleArns": NotRequired[Sequence[str]],
        "PaginationConfig": NotRequired[PaginatorConfigTypeDef],
    },
)

DescribeSSLPoliciesInputDescribeSSLPoliciesPaginateTypeDef = TypedDict(
    "DescribeSSLPoliciesInputDescribeSSLPoliciesPaginateTypeDef",
    {
        "Names": NotRequired[Sequence[str]],
        "LoadBalancerType": NotRequired[LoadBalancerTypeEnumType],
        "PaginationConfig": NotRequired[PaginatorConfigTypeDef],
    },
)

DescribeTargetGroupsInputDescribeTargetGroupsPaginateTypeDef = TypedDict(
    "DescribeTargetGroupsInputDescribeTargetGroupsPaginateTypeDef",
    {
        "LoadBalancerArn": NotRequired[str],
        "TargetGroupArns": NotRequired[Sequence[str]],
        "Names": NotRequired[Sequence[str]],
        "PaginationConfig": NotRequired[PaginatorConfigTypeDef],
    },
)

DescribeAccountLimitsOutputTypeDef = TypedDict(
    "DescribeAccountLimitsOutputTypeDef",
    {
        "Limits": List[LimitTypeDef],
        "NextMarker": str,
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

DescribeLoadBalancerAttributesOutputTypeDef = TypedDict(
    "DescribeLoadBalancerAttributesOutputTypeDef",
    {
        "Attributes": List[LoadBalancerAttributeTypeDef],
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

ModifyLoadBalancerAttributesInputRequestTypeDef = TypedDict(
    "ModifyLoadBalancerAttributesInputRequestTypeDef",
    {
        "LoadBalancerArn": str,
        "Attributes": Sequence[LoadBalancerAttributeTypeDef],
    },
)

ModifyLoadBalancerAttributesOutputTypeDef = TypedDict(
    "ModifyLoadBalancerAttributesOutputTypeDef",
    {
        "Attributes": List[LoadBalancerAttributeTypeDef],
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

DescribeLoadBalancersInputLoadBalancerAvailableWaitTypeDef = TypedDict(
    "DescribeLoadBalancersInputLoadBalancerAvailableWaitTypeDef",
    {
        "LoadBalancerArns": NotRequired[Sequence[str]],
        "Names": NotRequired[Sequence[str]],
        "Marker": NotRequired[str],
        "PageSize": NotRequired[int],
        "WaiterConfig": NotRequired[WaiterConfigTypeDef],
    },
)

DescribeLoadBalancersInputLoadBalancerExistsWaitTypeDef = TypedDict(
    "DescribeLoadBalancersInputLoadBalancerExistsWaitTypeDef",
    {
        "LoadBalancerArns": NotRequired[Sequence[str]],
        "Names": NotRequired[Sequence[str]],
        "Marker": NotRequired[str],
        "PageSize": NotRequired[int],
        "WaiterConfig": NotRequired[WaiterConfigTypeDef],
    },
)

DescribeLoadBalancersInputLoadBalancersDeletedWaitTypeDef = TypedDict(
    "DescribeLoadBalancersInputLoadBalancersDeletedWaitTypeDef",
    {
        "LoadBalancerArns": NotRequired[Sequence[str]],
        "Names": NotRequired[Sequence[str]],
        "Marker": NotRequired[str],
        "PageSize": NotRequired[int],
        "WaiterConfig": NotRequired[WaiterConfigTypeDef],
    },
)

DescribeTargetHealthInputTargetDeregisteredWaitTypeDef = TypedDict(
    "DescribeTargetHealthInputTargetDeregisteredWaitTypeDef",
    {
        "TargetGroupArn": str,
        "Targets": NotRequired[Sequence[TargetDescriptionTypeDef]],
        "WaiterConfig": NotRequired[WaiterConfigTypeDef],
    },
)

DescribeTargetHealthInputTargetInServiceWaitTypeDef = TypedDict(
    "DescribeTargetHealthInputTargetInServiceWaitTypeDef",
    {
        "TargetGroupArn": str,
        "Targets": NotRequired[Sequence[TargetDescriptionTypeDef]],
        "WaiterConfig": NotRequired[WaiterConfigTypeDef],
    },
)

DescribeTargetGroupAttributesOutputTypeDef = TypedDict(
    "DescribeTargetGroupAttributesOutputTypeDef",
    {
        "Attributes": List[TargetGroupAttributeTypeDef],
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

ModifyTargetGroupAttributesInputRequestTypeDef = TypedDict(
    "ModifyTargetGroupAttributesInputRequestTypeDef",
    {
        "TargetGroupArn": str,
        "Attributes": Sequence[TargetGroupAttributeTypeDef],
    },
)

ModifyTargetGroupAttributesOutputTypeDef = TypedDict(
    "ModifyTargetGroupAttributesOutputTypeDef",
    {
        "Attributes": List[TargetGroupAttributeTypeDef],
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

ForwardActionConfigPaginatorTypeDef = TypedDict(
    "ForwardActionConfigPaginatorTypeDef",
    {
        "TargetGroups": NotRequired[List[TargetGroupTupleTypeDef]],
        "TargetGroupStickinessConfig": NotRequired[TargetGroupStickinessConfigTypeDef],
    },
)

ForwardActionConfigTypeDef = TypedDict(
    "ForwardActionConfigTypeDef",
    {
        "TargetGroups": NotRequired[Sequence[TargetGroupTupleTypeDef]],
        "TargetGroupStickinessConfig": NotRequired[TargetGroupStickinessConfigTypeDef],
    },
)

QueryStringConditionConfigPaginatorTypeDef = TypedDict(
    "QueryStringConditionConfigPaginatorTypeDef",
    {
        "Values": NotRequired[List[QueryStringKeyValuePairTypeDef]],
    },
)

QueryStringConditionConfigTypeDef = TypedDict(
    "QueryStringConditionConfigTypeDef",
    {
        "Values": NotRequired[Sequence[QueryStringKeyValuePairTypeDef]],
    },
)

SetRulePrioritiesInputRequestTypeDef = TypedDict(
    "SetRulePrioritiesInputRequestTypeDef",
    {
        "RulePriorities": Sequence[RulePriorityPairTypeDef],
    },
)

TargetHealthDescriptionTypeDef = TypedDict(
    "TargetHealthDescriptionTypeDef",
    {
        "Target": NotRequired[TargetDescriptionTypeDef],
        "HealthCheckPort": NotRequired[str],
        "TargetHealth": NotRequired[TargetHealthTypeDef],
    },
)

DescribeTagsOutputTypeDef = TypedDict(
    "DescribeTagsOutputTypeDef",
    {
        "TagDescriptions": List[TagDescriptionTypeDef],
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

LoadBalancerTypeDef = TypedDict(
    "LoadBalancerTypeDef",
    {
        "LoadBalancerArn": NotRequired[str],
        "DNSName": NotRequired[str],
        "CanonicalHostedZoneId": NotRequired[str],
        "CreatedTime": NotRequired[datetime],
        "LoadBalancerName": NotRequired[str],
        "Scheme": NotRequired[LoadBalancerSchemeEnumType],
        "VpcId": NotRequired[str],
        "State": NotRequired[LoadBalancerStateTypeDef],
        "Type": NotRequired[LoadBalancerTypeEnumType],
        "AvailabilityZones": NotRequired[List[AvailabilityZoneTypeDef]],
        "SecurityGroups": NotRequired[List[str]],
        "IpAddressType": NotRequired[IpAddressTypeType],
        "CustomerOwnedIpv4Pool": NotRequired[str],
        "EnforceSecurityGroupInboundRulesOnPrivateLinkTraffic": NotRequired[str],
    },
)

SetSubnetsOutputTypeDef = TypedDict(
    "SetSubnetsOutputTypeDef",
    {
        "AvailabilityZones": List[AvailabilityZoneTypeDef],
        "IpAddressType": IpAddressTypeType,
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

DescribeSSLPoliciesOutputTypeDef = TypedDict(
    "DescribeSSLPoliciesOutputTypeDef",
    {
        "SslPolicies": List[SslPolicyTypeDef],
        "NextMarker": str,
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

CreateTargetGroupOutputTypeDef = TypedDict(
    "CreateTargetGroupOutputTypeDef",
    {
        "TargetGroups": List[TargetGroupTypeDef],
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

DescribeTargetGroupsOutputTypeDef = TypedDict(
    "DescribeTargetGroupsOutputTypeDef",
    {
        "TargetGroups": List[TargetGroupTypeDef],
        "NextMarker": str,
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

ModifyTargetGroupOutputTypeDef = TypedDict(
    "ModifyTargetGroupOutputTypeDef",
    {
        "TargetGroups": List[TargetGroupTypeDef],
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

ActionPaginatorTypeDef = TypedDict(
    "ActionPaginatorTypeDef",
    {
        "Type": ActionTypeEnumType,
        "TargetGroupArn": NotRequired[str],
        "AuthenticateOidcConfig": NotRequired[AuthenticateOidcActionConfigPaginatorTypeDef],
        "AuthenticateCognitoConfig": NotRequired[AuthenticateCognitoActionConfigPaginatorTypeDef],
        "Order": NotRequired[int],
        "RedirectConfig": NotRequired[RedirectActionConfigTypeDef],
        "FixedResponseConfig": NotRequired[FixedResponseActionConfigTypeDef],
        "ForwardConfig": NotRequired[ForwardActionConfigPaginatorTypeDef],
    },
)

ActionTypeDef = TypedDict(
    "ActionTypeDef",
    {
        "Type": ActionTypeEnumType,
        "TargetGroupArn": NotRequired[str],
        "AuthenticateOidcConfig": NotRequired[AuthenticateOidcActionConfigTypeDef],
        "AuthenticateCognitoConfig": NotRequired[AuthenticateCognitoActionConfigTypeDef],
        "Order": NotRequired[int],
        "RedirectConfig": NotRequired[RedirectActionConfigTypeDef],
        "FixedResponseConfig": NotRequired[FixedResponseActionConfigTypeDef],
        "ForwardConfig": NotRequired[ForwardActionConfigTypeDef],
    },
)

RuleConditionPaginatorTypeDef = TypedDict(
    "RuleConditionPaginatorTypeDef",
    {
        "Field": NotRequired[str],
        "Values": NotRequired[List[str]],
        "HostHeaderConfig": NotRequired[HostHeaderConditionConfigPaginatorTypeDef],
        "PathPatternConfig": NotRequired[PathPatternConditionConfigPaginatorTypeDef],
        "HttpHeaderConfig": NotRequired[HttpHeaderConditionConfigPaginatorTypeDef],
        "QueryStringConfig": NotRequired[QueryStringConditionConfigPaginatorTypeDef],
        "HttpRequestMethodConfig": NotRequired[HttpRequestMethodConditionConfigPaginatorTypeDef],
        "SourceIpConfig": NotRequired[SourceIpConditionConfigPaginatorTypeDef],
    },
)

RuleConditionTypeDef = TypedDict(
    "RuleConditionTypeDef",
    {
        "Field": NotRequired[str],
        "Values": NotRequired[Sequence[str]],
        "HostHeaderConfig": NotRequired[HostHeaderConditionConfigTypeDef],
        "PathPatternConfig": NotRequired[PathPatternConditionConfigTypeDef],
        "HttpHeaderConfig": NotRequired[HttpHeaderConditionConfigTypeDef],
        "QueryStringConfig": NotRequired[QueryStringConditionConfigTypeDef],
        "HttpRequestMethodConfig": NotRequired[HttpRequestMethodConditionConfigTypeDef],
        "SourceIpConfig": NotRequired[SourceIpConditionConfigTypeDef],
    },
)

DescribeTargetHealthOutputTypeDef = TypedDict(
    "DescribeTargetHealthOutputTypeDef",
    {
        "TargetHealthDescriptions": List[TargetHealthDescriptionTypeDef],
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

CreateLoadBalancerOutputTypeDef = TypedDict(
    "CreateLoadBalancerOutputTypeDef",
    {
        "LoadBalancers": List[LoadBalancerTypeDef],
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

DescribeLoadBalancersOutputTypeDef = TypedDict(
    "DescribeLoadBalancersOutputTypeDef",
    {
        "LoadBalancers": List[LoadBalancerTypeDef],
        "NextMarker": str,
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

ListenerPaginatorTypeDef = TypedDict(
    "ListenerPaginatorTypeDef",
    {
        "ListenerArn": NotRequired[str],
        "LoadBalancerArn": NotRequired[str],
        "Port": NotRequired[int],
        "Protocol": NotRequired[ProtocolEnumType],
        "Certificates": NotRequired[List[CertificateTypeDef]],
        "SslPolicy": NotRequired[str],
        "DefaultActions": NotRequired[List[ActionPaginatorTypeDef]],
        "AlpnPolicy": NotRequired[List[str]],
    },
)

CreateListenerInputRequestTypeDef = TypedDict(
    "CreateListenerInputRequestTypeDef",
    {
        "LoadBalancerArn": str,
        "DefaultActions": Sequence[ActionTypeDef],
        "Protocol": NotRequired[ProtocolEnumType],
        "Port": NotRequired[int],
        "SslPolicy": NotRequired[str],
        "Certificates": NotRequired[Sequence[CertificateTypeDef]],
        "AlpnPolicy": NotRequired[Sequence[str]],
        "Tags": NotRequired[Sequence[TagTypeDef]],
    },
)

ListenerTypeDef = TypedDict(
    "ListenerTypeDef",
    {
        "ListenerArn": NotRequired[str],
        "LoadBalancerArn": NotRequired[str],
        "Port": NotRequired[int],
        "Protocol": NotRequired[ProtocolEnumType],
        "Certificates": NotRequired[List[CertificateTypeDef]],
        "SslPolicy": NotRequired[str],
        "DefaultActions": NotRequired[List[ActionTypeDef]],
        "AlpnPolicy": NotRequired[List[str]],
    },
)

ModifyListenerInputRequestTypeDef = TypedDict(
    "ModifyListenerInputRequestTypeDef",
    {
        "ListenerArn": str,
        "Port": NotRequired[int],
        "Protocol": NotRequired[ProtocolEnumType],
        "SslPolicy": NotRequired[str],
        "Certificates": NotRequired[Sequence[CertificateTypeDef]],
        "DefaultActions": NotRequired[Sequence[ActionTypeDef]],
        "AlpnPolicy": NotRequired[Sequence[str]],
    },
)

RulePaginatorTypeDef = TypedDict(
    "RulePaginatorTypeDef",
    {
        "RuleArn": NotRequired[str],
        "Priority": NotRequired[str],
        "Conditions": NotRequired[List[RuleConditionPaginatorTypeDef]],
        "Actions": NotRequired[List[ActionPaginatorTypeDef]],
        "IsDefault": NotRequired[bool],
    },
)

CreateRuleInputRequestTypeDef = TypedDict(
    "CreateRuleInputRequestTypeDef",
    {
        "ListenerArn": str,
        "Conditions": Sequence[RuleConditionTypeDef],
        "Priority": int,
        "Actions": Sequence[ActionTypeDef],
        "Tags": NotRequired[Sequence[TagTypeDef]],
    },
)

ModifyRuleInputRequestTypeDef = TypedDict(
    "ModifyRuleInputRequestTypeDef",
    {
        "RuleArn": str,
        "Conditions": NotRequired[Sequence[RuleConditionTypeDef]],
        "Actions": NotRequired[Sequence[ActionTypeDef]],
    },
)

RuleTypeDef = TypedDict(
    "RuleTypeDef",
    {
        "RuleArn": NotRequired[str],
        "Priority": NotRequired[str],
        "Conditions": NotRequired[List[RuleConditionTypeDef]],
        "Actions": NotRequired[List[ActionTypeDef]],
        "IsDefault": NotRequired[bool],
    },
)

DescribeListenersOutputPaginatorTypeDef = TypedDict(
    "DescribeListenersOutputPaginatorTypeDef",
    {
        "Listeners": List[ListenerPaginatorTypeDef],
        "NextMarker": str,
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

CreateListenerOutputTypeDef = TypedDict(
    "CreateListenerOutputTypeDef",
    {
        "Listeners": List[ListenerTypeDef],
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

DescribeListenersOutputTypeDef = TypedDict(
    "DescribeListenersOutputTypeDef",
    {
        "Listeners": List[ListenerTypeDef],
        "NextMarker": str,
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

ModifyListenerOutputTypeDef = TypedDict(
    "ModifyListenerOutputTypeDef",
    {
        "Listeners": List[ListenerTypeDef],
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

DescribeRulesOutputPaginatorTypeDef = TypedDict(
    "DescribeRulesOutputPaginatorTypeDef",
    {
        "Rules": List[RulePaginatorTypeDef],
        "NextMarker": str,
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

CreateRuleOutputTypeDef = TypedDict(
    "CreateRuleOutputTypeDef",
    {
        "Rules": List[RuleTypeDef],
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

DescribeRulesOutputTypeDef = TypedDict(
    "DescribeRulesOutputTypeDef",
    {
        "Rules": List[RuleTypeDef],
        "NextMarker": str,
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

ModifyRuleOutputTypeDef = TypedDict(
    "ModifyRuleOutputTypeDef",
    {
        "Rules": List[RuleTypeDef],
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)

SetRulePrioritiesOutputTypeDef = TypedDict(
    "SetRulePrioritiesOutputTypeDef",
    {
        "Rules": List[RuleTypeDef],
        "ResponseMetadata": ResponseMetadataTypeDef,
    },
)
